#define __OPRDR_H

#ifndef __QINIMGR_H
#include "qinimgr.h"
#endif

typedef unsigned int UINT;

struct pmgrupinfo;
struct pmiteminfo;

class oprdr
{
   public:

   virtual void mkdir(char dir[]) = 0;
   virtual void deldir(char dir[]) = 0;
   virtual void renfile(char oldpath[], char newpath[]) = 0;
   virtual void delfile(char path[]) = 0;
   virtual void copyfile(char srcpath[], char dstpath[], int isshared) = 0;
   virtual void createfile(char path[]) = 0;
   virtual void setfileattr(char path[], UINT oldflags, UINT newflags) = 0;
   virtual void insinientry(char file[], char sect[], char entry[], int seqno) = 0;
   virtual void delinientry(char file[], char sect[], char entry[], char oldv[], int seqno) = 0;
   virtual void setinivalue(char file[], char sect[], char entry[], char oldv[], int seqno) = 0;
   virtual void addinisect(char file[], char sect[]) = 0;
   virtual void delinisect(char file[], char sect[]) = 0;
   virtual void addgrup(char grup[]) = 0;
   virtual void additem(char grup[], char item[]) = 0;
   virtual void delgrup(char grup[]) = 0;
   virtual void delitem(char grup[], pmiteminfo &pmii) = 0;
   virtual void addregkey(char kpath[]) = 0;
   virtual void setregkey(char kpath[], char value[]) = 0;
   virtual void delregkey(char kpath[], char value[]) = 0;
};

class voidrdr:public oprdr
{
   public:
   void mkdir(char dir[])
   {

   }
   void deldir(char dir[])
   {

   }
   void renfile(char oldpath[], char newpath[])
   {

   }
   void delfile(char path[])
   {

   }
   void copyfile(char srcpath[], char dstpath[], int isshared)
   {

   }
   void createfile(char path[])
   {

   }
   void setfileattr(char path[], UINT oldflags, UINT newflags)
   {

   }
   void insinientry(char file[], char sect[], char entry[], int seqno)
   {

   }
   void delinientry(char file[], char sect[], char entry[], char oldv[], int seqno)
   {

   }
   void setinivalue(char file[], char sect[], char entry[], char oldv[], int seqno)
   {

   }
   void addinisect(char file[], char sect[])
   {

   }
   void delinisect(char file[], char sect[])
   {

   }
   void addgrup(char grup[])
   {

   } 
   void additem(char grup[], char item[])
   {

   } 
   void delgrup(char grup[])
   {

   } 
   void delitem(char grup[], pmiteminfo &pmii)
   {

   } 
   void addregkey(char kpath[])
   {

   }
   void setregkey(char kpath[], char value[])
   {

   }
   void delregkey(char kpath[], char value[])
   {

   }
};

class oprecorder:public oprdr
{
   int noops;
   int noopsmkdir;
   int noopsdeldir;
   int noopssetiniv;
   int noopsdelinie;
   int noopsinsinie;
   int noopsaddinis;
   int noopsdelinis;
   int noopsrenfile;
   int noopsdelfile;
   int noopsaddgrup;
   int noopsadditem;
   int noopsdelgrup;
   int noopsdelitem;
   int noopscopyfile;
   int noopssetfilea;
   int noopsaddregkey;
   int noopssetregkey;
   int noopsdelregkey;
   int noopscreatefile;
   qinimgr im;                                            /* quick ini manager */


   public:
   oprecorder()                                        /* must call init later */
   {

   }
   oprecorder(int *r, char appname[], char logdir[]);

   int init(char appname[], char logdir[]);
   void mkdir(char dir[]);
   void deldir(char dir[]);
   void renfile(char oldpath[], char newpath[]);
   void delfile(char path[]);
   void copyfile(char srcpath[], char dstpath[], int isshared);
   void createfile(char path[]);
   void setfileattr(char path[], UINT oldflags, UINT newflags);
   void insinientry(char file[], char sect[], char entry[], int seqno);
   void delinientry(char file[], char sect[], char entry[], char oldv[], int seqno);
   void setinivalue(char file[], char sect[], char entry[], char oldv[], int seqno);
   void addinisect(char file[], char sect[]);
   void delinisect(char file[], char sect[]);
   void addgrup(char grup[]);
   void additem(char grup[], char item[]); 
   void delgrup(char grup[]); 
   void delitem(char grup[], pmiteminfo &pmii);
   void addregkey(char kpath[]);
   void setregkey(char kpath[], char value[]);
   void delregkey(char kpath[], char value[]);
};

